<?xml version="1.0" encoding="UTF-8"?>
<!--
    *  Copyright (c) 2019, Entgra (Pvt) Ltd. (http://www.entgra.io) All Rights Reserved.
    *
    * Entgra (Pvt) Ltd. licenses this file to you under the Apache License,
    * Version 2.0 (the "License"); you may not use this file except
    * in compliance with the License.
    * You may obtain a copy of the License at
    *
    *    http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing,
    * software distributed under the License is distributed on an
    * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    * KIND, either express or implied. See the License for the
    * specific language governing permissions and limitations
    * under the License.
  -->
<beans xmlns="http://www.springframework.org/schema/beans"
       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
       xmlns:jaxrs="http://cxf.apache.org/jaxrs" xmlns:cxf="http://cxf.apache.org/core"
       xsi:schemaLocation="http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans-2.0.xsd
         http://cxf.apache.org/jaxrs http://cxf.apache.org/schemas/jaxrs.xsd http://cxf.apache.org/core http://cxf.apache.org/schemas/core.xsd">


    <jaxrs:server id="applicationMgtCommonService" address="/">
        <jaxrs:serviceBeans>
            <ref bean="applicationMgtArtifactService"/>
            <ref bean="swaggerResource"/>
        </jaxrs:serviceBeans>
        <jaxrs:providers>
            <ref bean="jsonProvider"/>
            <ref bean="multipartProvider"/>
            <ref bean="swaggerWriter"/>
        </jaxrs:providers>
    </jaxrs:server>

    <bean id="swaggerConfig" class="io.swagger.jaxrs.config.BeanConfig">
        <property name="resourcePackage" value="org.wso2.carbon.device.application.mgt.publisher.api"/>
        <property name="version" value="1.0"/>
        <property name="host" value="localhost:9443"/>
        <property name="schemes" value="https" />
        <property name="basePath" value="/api/application-mgt-publisher/v1.0"/>
        <property name="title" value="Application Management Admin Service API Definitions"/>
        <property name="contact" value="dev@wso2.org"/>
        <property name="license" value="Apache 2.0"/>
        <property name="licenseUrl" value="http://www.apache.org/licenses/LICENSE-2.0.html"/>
        <property name="scan" value="true"/>
    </bean>

    <bean id="org.wso2.carbon.device.application.mgt.addons.ValidationInterceptor" class="org.wso2.carbon.device.application.mgt.addons.ValidationInterceptor"/>
    <bean id="swaggerWriter" class="io.swagger.jaxrs.listing.SwaggerSerializers" />
    <bean id="swaggerResource" class="io.swagger.jaxrs.listing.ApiListingResource" />

    <bean id="applicationMgtArtifactService" class="org.wso2.carbon.device.application.mgt.api.services.impl.ArtifactDownloadAPIImpl"/>
    <bean id="jsonProvider" class="org.wso2.carbon.device.application.mgt.addons.JSONMessageHandler"/>
    <bean id="multipartProvider" class="org.wso2.carbon.device.application.mgt.addons.MultipartCustomProvider"/>

    <cxf:bus>
        <cxf:inInterceptors>
            <ref bean="org.wso2.carbon.device.application.mgt.addons.ValidationInterceptor"/>
        </cxf:inInterceptors>
    </cxf:bus>

</beans>


